#!/usr/bin/perl

#
#   mkSpeedbar.tcl
#
#   Description see below.
#
#     Copyright (C) 2005, Patrick Rammelt <rammelt@cs.tu-berlin.de>
#
#     This program is free software; you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation; either version 2 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program; if not, write to the Free Software
#     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#

# get parameters (via cgi-object)
# use CGI;
# $cgi   = new CGI;

# get parameters
my %FORM;
$FORM{path} = "../index.html";
&form2hash;

my @path = split (/\+/, $FORM{path});

# ---------------------------------------------------------------------------------
# PROBNET

my @probnetlearnsub = (["../probnet/DiplomArbeit.ps", "Diplom-Arbeit (PS)",   []],
		       ["../probnet/DiplomArbeit.pdf", "Diplom-Arbeit (PDF)", []]);

my @probnetsub = (["../probnet/index.html#Einfuehrung", "Einführung",           []],
		  ["../probnet/index.html#dseparation", "dseparation",          []],
		  ["../probnet/index.html#inferenz",    "Inferenz",             []],
		  ["../probnet/index.html#Rules",       "Rechenregeln",         []],
		  ["../probnet/index.html#Bsp",         "Beispiel",             []],
		  ["../probnet/bn_bsp.html",            "Anwendungs-Beispiele", []],
		  ["../probnet/bn_dyn.html",            "dynamische Netze",     []],
		  ["../probnet/bn_learn.html",          "Daten (lernen)",       \@probnetlearnsub],
		  ["../probnet/bn_plugin.html",         "Plugin",               []],
		  ["../probnet/index.html#Frosch",      "Der Frosch",           []],
		  ["../probnet/index.html#Glossar",     "Glossar",              []]);

# ---------------------------------------------------------------------------------
# FRAKTAL

my @fractalcodesub1 = (["../fractal/fract3dcode.html#Komplex_Quaternion", "Complex / Quaternions",        []],
		       ["../fractal/fract3dcode.html#Julia_Mandelbrot",   "Mandelbrot- / Julia-Fraktale", []]);

my @fractalcodesub2 = (["../fractal/fract3dcode2.html#Object",   "Basis-Klasse", []],
		       ["../fractal/fract3dcode2.html#Vector",   "3D-Vector",    []],
		       ["../fractal/fract3dcode2.html#Line",     "3D-Geraden",   []],
		       ["../fractal/fract3dcode2.html#Plane",    "3D-Ebenen",    []],
		       ["../fractal/fract3dcode2.html#Rotation", "Rotation",     []]);

my @fractalsub = (["../fractal/fract3dcode2.html",  "Code: Geometrie",   \@fractalcodesub2],
		  ["../fractal/fract3dcode.html",   "Code: Fraktale",    \@fractalcodesub1],
		  ["../cgi-bin/julia3dcreate.html", "Fraktal-Generator", []],                # start path with ../
		  ["../fractal/index.html#galerie", "Galerie",           []]);

# ---------------------------------------------------------------------------------
# BEZIER

my @beziersubsub1 = (["../bezier/index.html#Basics",                           "Basics",               []],
		     ["../bezier/index.html#Forward_Differencing",             "Forward-Differencing", []],
		     ["../bezier/index.html#Zusammenfuegen_von_Bezier_Kurven", "Zusammenfügen",        []]);

my @beziersubsub2 = (["../bezier/index.html#Basics",                           "Basics2",         []],
		     ["../bezier/index.html#Zusammenfuegbare_Bezier_Flaechen", "Zusammenfügen",   []],
		     ["../bezier/index.html#Gesichtsmodell",                   "Gesichtsmodell",  []],
		     ["../bezier/index.html#Greatest_Misses",                  "Greatest Misses", []],
		     ["../bezier/index.html#Ergebnis",                         "Ergebnis",        []]);

my @beziersubsub3 = (["../bezier/bezier3dcode.html#Forward_Diff_Curve",        "Forward-Diff (Curve)",    []],
		     ["../bezier/bezier3dcode.html#Curve_Intermediates",       "Intermediates (Curve)",   []],
		     ["../bezier/bezier3dcode.html#Forward_Diff_Surface",      "Forward-Diff (Surface)",  []],
		     ["../bezier/bezier3dcode.html#Surface_Intermediates",     "Intermediates (Surface)", []]);

my @beziersub = (["../bezier/index.html#Bezier_Kurven",       "Bezier-Kurven",      \@beziersubsub1],
		 ["../bezier/index.html#Bezier_Oberflaechen", "Bezier-Oberflächen", \@beziersubsub2],
		 ["../bezier/bezier3dcode.html",              "Code",               \@beziersubsub3]);
# ---------------------------------------------------------------------------------
# OPTICAL

my @optsubsubsub1 = (["../optical/optF2.html", "Lösung 2", []]);

my @optsubsub1 = (["../optical/optF.html", "Lösung", \@optsubsubsub1]);

my @optsubsub2 = (["../optical/diff.html", "Lösung", []]);

my @optsubsub3 = (["../optical/optface.html", "Lösung", []]);

my @optsub = (["../optical/index.html#timegap",    "Wechselbild",     \@optsubsub2],
	      ["../optical/index.html#countf",     "F\'s zählen",     \@optsubsub1],
	      ["../optical/index.html#mixed",      "Buchstabensalat", []],
	      ["../optical/index.html#colors",     "Farben",          []],
	      ["../optical/index.html#upsidedown", "Kopfüber",        \@optsubsub3]);

# ---------------------------------------------------------------------------------
# WAVELETS

my @dwtsub = (["../wavelets/index.html#1D",        "1D-DWT",             []],
	      ["../wavelets/index.html#1DML",      "1D-Multi-Level-DWT", []],
	      ["../wavelets/index.html#2DML",      "2D-Multi-Level-DWT", []],
	      ["../wavelets/index.html#reduction", "Teilinformation",    []],
	      ["../wavelets/index.html#denoise",   "Bildglättung",       []],
	      ["../wavelets/index.html#results",   "Resultate",          []],
	      ["../wavelets/index.html#coeff",     "Anhang (Filter)",    []]);

# ---------------------------------------------------------------------------------
# CODE

my @codesub = (["../code/index.html#contentManager", "Content-Manager (C++)", []],
	       ["../code/index.html#d3",             "3-D (C++)",             []],
	       ["../code/index.html#photoimage",     "Tiff/Jpeg (C++)",       []],
	       ["../code/index.html#psprint",        "PS-Print",              []]);

# ---------------------------------------------------------------------------------
# RADWEG

my @radsub = (["../radweg/index.html#Heckerdamm",            "Heckerdamm",              []],
	      ["../radweg/index.html#KaiserFriedrichStrasse","Kaiser-Friedrich-Straße", []],
	      ["../radweg/index.html#KurtSchumacherDamm",    "Kurt-Schumacher-Damm",    []],
	      ["../radweg/index.html#KurtSchumacherPlatz",   "Kurt-Schumacher-Platz",   []],
	      ["../radweg/index.html#NeuendorferStrasse",    "Neuendorfer Straße",      []],
	      ["../radweg/index.html#NonnenDammAllee",       "Nonnen-Damm-Allee",       []],
	      ["../radweg/index.html#OllenhauerStrasse",     "Ollenhauer Straße",       []],
	      ["../radweg/index.html#OranienburgerStrasse",  "OranienburgerStraße",     []],
	      ["../radweg/index.html#LuisenPlatz",           "Luisenplatz",             []],
	      ["../radweg/index.html#BernauerStrasse",       "Bernauer Straße",         []],
	      ["../radweg/index.html#FuerstenbrunnerWeg",    "Fürstenbrunner Weg",      []],
	      ["../radweg/index.html#Muellerstrasse",        "Müllerstraße",            []],
	      ["../radweg/index.html#NeheimerStrasse",       "Neheimer Straße",         []],
	      ["../radweg/index.html#Reichstag",             "Reichstag",               []],
	      ["../radweg/index.html#PotsdamerPlatz",        "Potsdamer Platz",         []],
	      ["../radweg/index.html#LuetzowPlatz",          "Lützowplatz",             []],
	      ["../radweg/index.html#OranienburgerChaussee", "Oranienburger Chaussee",  []]);

# ---------------------------------------------------------------------------------
# FAHRRAD

my @tourFsub = (["../bicycle/Frankreich.html#Korsika",   "Korsika",                      []],
		["../bicycle/Frankreich.html#Pyrenaeen", "Pyrenäen I",                   []],
		["../bicycle/Frankreich.html#Atlantik",  "Pyrenäen II, Atlantik, Paris", []],
		["../bicycle/Frankreich.html#CoteDAzur", "Cote d\'Azur, Provence",       []]);

my @tourIsub = (["../bicycle/Italien.html#Verona",  "Verona - Dolomiten - Ligurien - Toskana", []],
		["../bicycle/Italien.html#Trieste", "Trieste",                                 []]);

my @tourHRsub = (["../bicycle/Krotien.html#Istrien",        "Istrien",      []],
		 ["../bicycle/Krotien.html#Kuestenstrasse", "Küstenstraße", []]);


my @toursub = (["../bicycle/index.html#Karte", "Karte",      []],
	       ["../bicycle/Frankreich.html",  "Frankreich", \@tourFsub],
	       ["../bicycle/Spanien.html",     "Spanien",    []],
	       ["../bicycle/Italien.html",     "Italien",    \@tourIsub],
	       ["../bicycle/Oesterreich.html", "Österreich", []],
	       ["../bicycle/Slowenien.html",   "Slowenien",  []],
	       ["../bicycle/Krotien.html",     "Kroatien",   \@tourHRsub],
	       ["../bicycle/Deutschland.html", "Deutschland", []],
	       ["../bicycle/Technik.html",     "Technik",     []]);


# ---------------------------------------------------------------------------------
# HOME

my @homesub = (["../ghana.html",             "Ghana",                   []],
	       ["../probnet/index.html",     "Bayes\'sche Netze",       \@probnetsub],
	       ["../fractal/index.html",     "Fraktale",                \@fractalsub],
	       ["../bezier/index.html",      "Bezier-Surfaces",         \@beziersub],
	       ["../bicycle/index.html",     "Fahrrad",                 \@toursub],
	       ["../radweg/index.html",      "Radweg",                  \@radsub],
	       ["../lut/index.html",         "OCR",                     []],
	       ["../optical/index.html",     "Opt. Täuschung",          \@optsub],
	       ["../arts/index.html",        "Gekrickel",               []],
	       ["../profiler/index.html",    "Profiler",                []],
	       ["../wavelets/index.html",    "Bildglättung",            \@dwtsub],
	       ["../code/index.html",        "Code",                    \@codesub],
	       ["../Patrick_Rammelt.html",   "streng privat",           []],
	       ["../index.html#MessageForm", "Schreib mir doch mal...", []]);

my @home = (["../index.html","home", \@homesub]);

# ---------------------------------------------------------------------------------

# open output-stream
open(HTML,">-");          # print to stdout
#open(HTML,">temp.html"); # TEST print to file

# print header
print HTML "<html>\n";
print HTML "<head>\n";
print HTML "<meta http-equiv=\"content-type\" content=\"text/html; charset=ISO-8859-1\">\n";
print HTML "<meta http-equiv=\"cache-control\" content=\"no-cache; must-revalidate\">\n";
print HTML "<title>Speedbar</title>\n";
print HTML "</head>\n";
print HTML "<body text=\"#ffffff\" bgcolor=\"#000000\" link=\"#ffffff\" vlink=\"#ffffff\" alink=\"#ffffff\">\n";

# print speedbar
print HTML "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n";
print HTML "<tbody>\n";

&recTree(\@home,"",\@path,0);

print HTML "</tbody>\n";
print HTML "</table>\n";

# print end
print HTML "</body>\n";
print HTML "</html>\n";


# close output-stream
close HTML;


# ---------------------- #
# recursively print tree #
# ---------------------- #
sub recTree {
  my $dir     = $_[0];           # ref to array
  my $curr    = $_[1];           # ref to array (current path)
  my $path    = $_[2];           # ref to array (path to open)
  my $depth   = $_[3];           # scalar
  my $thisUrl = $path->[$depth];
  my $pathlen = @{$path};

  foreach $elem (@{$dir}) {

    my $url    = $elem->[0];
    my $text   = $elem->[1];
    my $sub    = $elem->[2];
    my $sublen = @{$sub};

    if ($sublen) { $text = "$text ($sublen)"; }

    push(@{$curr},$url);
    my $ref = join("+",@{$curr});
    $ref =~ s/\#/\%/g; # change # back to %

    my $pic = ".leaf.gif";
    if ($url eq $thisUrl) {
      if ($sublen) { $pic = ".opened.gif"; }
      &treeItem($pic, $text, $ref, $depth, $depth==$pathlen-1);
      &recTree($sub,$curr,$path,$depth+1);
    } else {
      if ($sublen) { $pic = ".closed.gif"; }
      &treeItem($pic, $text, $ref, $depth, 0);
    }

    pop(@{$curr});

  }

}


# --------------- #
# print tree item #
# --------------- #
sub treeItem {
  my $thispic   = $_[0];
  my $thistext  = $_[1];
  my $thisref   = $_[2];
  my $thisdepth = $_[3];
  my $thismark  = $_[4];
  my $margin    = 15;

  my $bg = "";
  if ($thismark) { $bg = "bgcolor=\"#666666\""; }

  print HTML "<tr>\n";
  print HTML "<td valign=\"middle\" nowrap=\"true\" width=\"$margin\"></td>\n" x $thisdepth;
  print HTML "<td valign=\"middle\" nowrap=\"true\" width=\"$margin\" $bg>\n";
  print HTML "<a href=\"withSpeedbar.cgi?path=$thisref\" target=\"_top\">";
  print HTML "<img src=\"$thispic\" border=\"0\">";
  print HTML "</a>\n";
  print HTML "</td>\n";

  print HTML "<td valign=\"middle\" nowrap=\"true\" colspan=\"20\" $bg>\n";
  print HTML "<a href=\"withSpeedbar.cgi?path=$thisref\" target=\"_top\">\n";
  print HTML "<small><small>\n";
  print HTML &txt2html($thistext);
  print HTML "</small></small>\n";
  print HTML "</a>\n";
  print HTML "</td>\n";
  print HTML "</tr>\n";
}


# ---------------- #
# convert to html  #
# ---------------- #
sub txt2html {
  $html = $_[0];
  $html =~ s/\&/\&\#038;/g; # (/g => replace all)
  $html =~ s/</\&\#060;/g;
  $html =~ s/>/\&\#062;/g;
  $html =~ s/ä/\&auml;/g;
  $html =~ s/ö/\&ouml;/g;
  $html =~ s/ü/\&uuml;/g;
  $html =~ s/Ä/\&Auml;/g;
  $html =~ s/Ö/\&Ouml;/g;
  $html =~ s/Ü/\&Uuml;/g;
  $html =~ s/ß/\&szlig;/g;
  $html =~ s/\r//g;
  $html =~ s/^---+\n/<hr width="100%" size="2">\n/g;  # horizontal line (start)
  $html =~ s/\n---+\n/<hr width="100%" size="2">\n/g; # horizontal line
  $html =~ s/\n/<br>/g;
  return $html
}


# ---------------------------- #
# read parameter into %FORM    #
# ---------------------------- #
sub form2hash {
  my ($buffer,@pairs,@pair,$i);
  if ($ENV{'REQUEST_METHOD'} eq "GET") { 
    $buffer = $ENV{'QUERY_STRING'}; 
  } else { 
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); 
  }

  @pairs = split(/&/, $buffer);
  foreach (@pairs) {
    @pair = split(/=/, $_, 2);
    for ($i=0;$i<2;$i++) {
      # $pair[$i] =~ tr/+/ /;
      $pair[$i] =~ s/\%/\#/g;
      $pair[$i] =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    }
    $FORM{$pair[0]} = $pair[1];
  }
}

